/* TimeUtils.c generated by valac 0.56.14, the Vala compiler
 * generated from TimeUtils.vala, do not modify */

/*
* Copyright (C) 2017-2021 Lains
*
* This program is free software; you can redistribute it &&/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <math.h>
#include <float.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define NOTEJOT_TYPE_TIME_UTILS (notejot_time_utils_get_type ())
#define NOTEJOT_TIME_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOTEJOT_TYPE_TIME_UTILS, NotejotTimeUtils))
#define NOTEJOT_TIME_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOTEJOT_TYPE_TIME_UTILS, NotejotTimeUtilsClass))
#define NOTEJOT_IS_TIME_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOTEJOT_TYPE_TIME_UTILS))
#define NOTEJOT_IS_TIME_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOTEJOT_TYPE_TIME_UTILS))
#define NOTEJOT_TIME_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOTEJOT_TYPE_TIME_UTILS, NotejotTimeUtilsClass))

typedef struct _NotejotTimeUtils NotejotTimeUtils;
typedef struct _NotejotTimeUtilsClass NotejotTimeUtilsClass;
typedef struct _NotejotTimeUtilsPrivate NotejotTimeUtilsPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _NotejotParamSpecTimeUtils NotejotParamSpecTimeUtils;

struct _NotejotTimeUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NotejotTimeUtilsPrivate * priv;
};

struct _NotejotTimeUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (NotejotTimeUtils *self);
};

struct _NotejotParamSpecTimeUtils {
	GParamSpec parent_instance;
};

static gpointer notejot_time_utils_parent_class = NULL;

VALA_EXTERN gpointer notejot_time_utils_ref (gpointer instance);
VALA_EXTERN void notejot_time_utils_unref (gpointer instance);
VALA_EXTERN GParamSpec* notejot_param_spec_time_utils (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void notejot_value_set_time_utils (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void notejot_value_take_time_utils (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer notejot_value_get_time_utils (const GValue* value);
VALA_EXTERN GType notejot_time_utils_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotejotTimeUtils, notejot_time_utils_unref)
VALA_EXTERN gboolean notejot_time_utils_is_same_day (GDateTime* day1,
                                         GDateTime* day2);
static gboolean notejot_time_utils_is_clock_format_12h (void);
VALA_EXTERN gchar* notejot_time_utils_get_default_date_format (gboolean with_weekday,
                                                   gboolean with_day,
                                                   gboolean with_year);
VALA_EXTERN gchar* notejot_time_utils_get_default_time_format (gboolean is_12h,
                                                   gboolean with_second);
VALA_EXTERN gchar* notejot_time_utils_get_relative_datetime (GDateTime* date_time);
VALA_EXTERN gchar* notejot_time_utils_get_relative_datetime_compact (GDateTime* date_time);
VALA_EXTERN NotejotTimeUtils* notejot_time_utils_new (void);
VALA_EXTERN NotejotTimeUtils* notejot_time_utils_construct (GType object_type);
static void notejot_time_utils_finalize (NotejotTimeUtils * obj);
static GType notejot_time_utils_get_type_once (void);

gboolean
notejot_time_utils_is_same_day (GDateTime* day1,
                                GDateTime* day2)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (day1 != NULL, FALSE);
	g_return_val_if_fail (day2 != NULL, FALSE);
	if (g_date_time_get_day_of_year (day1) == g_date_time_get_day_of_year (day2)) {
		_tmp0_ = g_date_time_get_year (day1) == g_date_time_get_year (day2);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
notejot_time_utils_is_clock_format_12h (void)
{
	GSettings* h24_settings = NULL;
	GSettings* _tmp0_;
	gchar* format = NULL;
	gchar* _tmp1_;
	gboolean result;
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
	h24_settings = _tmp0_;
	_tmp1_ = g_settings_get_string (h24_settings, "clock-format");
	format = _tmp1_;
	result = string_contains (format, "12h");
	_g_free0 (format);
	_g_object_unref0 (h24_settings);
	return result;
}

gchar*
notejot_time_utils_get_default_date_format (gboolean with_weekday,
                                            gboolean with_day,
                                            gboolean with_year)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp24_;
	gchar* result;
	if (with_weekday == TRUE) {
		_tmp1_ = with_day == TRUE;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = with_year == TRUE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("%a, %b %e, %Y"));
		result = _tmp2_;
		return result;
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		if (with_weekday == FALSE) {
			_tmp4_ = with_day == TRUE;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			_tmp3_ = with_year == TRUE;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("%b %e %Y"));
			result = _tmp5_;
			return result;
		} else {
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
			if (with_weekday == FALSE) {
				_tmp7_ = with_day == FALSE;
			} else {
				_tmp7_ = FALSE;
			}
			if (_tmp7_) {
				_tmp6_ = with_year == TRUE;
			} else {
				_tmp6_ = FALSE;
			}
			if (_tmp6_) {
				gchar* _tmp8_;
				_tmp8_ = g_strdup (_ ("%Y"));
				result = _tmp8_;
				return result;
			} else {
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
				if (with_weekday == FALSE) {
					_tmp10_ = with_day == TRUE;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					_tmp9_ = with_year == FALSE;
				} else {
					_tmp9_ = FALSE;
				}
				if (_tmp9_) {
					gchar* _tmp11_;
					_tmp11_ = g_strdup (_ ("%b %e"));
					result = _tmp11_;
					return result;
				} else {
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					if (with_weekday == TRUE) {
						_tmp13_ = with_day == FALSE;
					} else {
						_tmp13_ = FALSE;
					}
					if (_tmp13_) {
						_tmp12_ = with_year == TRUE;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						gchar* _tmp14_;
						_tmp14_ = g_strdup (_ ("%a %Y"));
						result = _tmp14_;
						return result;
					} else {
						gboolean _tmp15_ = FALSE;
						gboolean _tmp16_ = FALSE;
						if (with_weekday == TRUE) {
							_tmp16_ = with_day == FALSE;
						} else {
							_tmp16_ = FALSE;
						}
						if (_tmp16_) {
							_tmp15_ = with_year == FALSE;
						} else {
							_tmp15_ = FALSE;
						}
						if (_tmp15_) {
							gchar* _tmp17_;
							_tmp17_ = g_strdup (_ ("%a"));
							result = _tmp17_;
							return result;
						} else {
							gboolean _tmp18_ = FALSE;
							gboolean _tmp19_ = FALSE;
							if (with_weekday == TRUE) {
								_tmp19_ = with_day == TRUE;
							} else {
								_tmp19_ = FALSE;
							}
							if (_tmp19_) {
								_tmp18_ = with_year == FALSE;
							} else {
								_tmp18_ = FALSE;
							}
							if (_tmp18_) {
								gchar* _tmp20_;
								_tmp20_ = g_strdup (_ ("%a, %b %e"));
								result = _tmp20_;
								return result;
							} else {
								gboolean _tmp21_ = FALSE;
								gboolean _tmp22_ = FALSE;
								if (with_weekday == FALSE) {
									_tmp22_ = with_day == FALSE;
								} else {
									_tmp22_ = FALSE;
								}
								if (_tmp22_) {
									_tmp21_ = with_year == FALSE;
								} else {
									_tmp21_ = FALSE;
								}
								if (_tmp21_) {
									gchar* _tmp23_;
									_tmp23_ = g_strdup (_ ("%b"));
									result = _tmp23_;
									return result;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp24_ = g_strdup ("");
	result = _tmp24_;
	return result;
}

gchar*
notejot_time_utils_get_default_time_format (gboolean is_12h,
                                            gboolean with_second)
{
	gchar* result;
	if (is_12h == TRUE) {
		if (with_second == TRUE) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("%-l:%M:%S %p"));
			result = _tmp0_;
			return result;
		} else {
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("%-l:%M %p"));
			result = _tmp1_;
			return result;
		}
	} else {
		if (with_second == TRUE) {
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("%H:%M:%S"));
			result = _tmp2_;
			return result;
		} else {
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("%H:%M"));
			result = _tmp3_;
			return result;
		}
	}
}

gchar*
notejot_time_utils_get_relative_datetime (GDateTime* date_time)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* result;
	g_return_val_if_fail (date_time != NULL, NULL);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = now;
	diff = g_date_time_difference (_tmp1_, date_time);
	_tmp2_ = now;
	if (notejot_time_utils_is_same_day (date_time, _tmp2_)) {
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		if (diff > ((GTimeSpan) 0)) {
			if (diff < G_TIME_SPAN_MINUTE) {
				gchar* _tmp3_;
				_tmp3_ = g_strdup (_ ("Now"));
				result = _tmp3_;
				_g_date_time_unref0 (now);
				return result;
			} else {
				if (diff < G_TIME_SPAN_HOUR) {
					GTimeSpan minutes = 0LL;
					gchar* _tmp4_;
					minutes = diff / G_TIME_SPAN_MINUTE;
					_tmp4_ = g_strdup_printf (ngettext ("%d minute ago", "%d minutes ago", (gulong) minutes), (gint) minutes);
					result = _tmp4_;
					_g_date_time_unref0 (now);
					return result;
				} else {
					if (diff < (12 * G_TIME_SPAN_HOUR)) {
						gint rounded = 0;
						gchar* _tmp5_;
						rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
						_tmp5_ = g_strdup_printf (ngettext ("%d hour ago", "%d hours ago", (gulong) rounded), rounded);
						result = _tmp5_;
						_g_date_time_unref0 (now);
						return result;
					}
				}
			}
		} else {
			diff = -1 * diff;
			if (diff < G_TIME_SPAN_HOUR) {
				GTimeSpan minutes = 0LL;
				gchar* _tmp6_;
				minutes = diff / G_TIME_SPAN_MINUTE;
				_tmp6_ = g_strdup_printf (ngettext ("in %d minute", "in %d minutes", (gulong) minutes), (gint) minutes);
				result = _tmp6_;
				_g_date_time_unref0 (now);
				return result;
			} else {
				if (diff < (12 * G_TIME_SPAN_HOUR)) {
					gint rounded = 0;
					gchar* _tmp7_;
					rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
					_tmp7_ = g_strdup_printf (ngettext ("in %d hour", "in %d hours", (gulong) rounded), rounded);
					result = _tmp7_;
					_g_date_time_unref0 (now);
					return result;
				}
			}
		}
		_tmp8_ = notejot_time_utils_get_default_time_format (notejot_time_utils_is_clock_format_12h (), FALSE);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_date_time_format (date_time, _tmp9_);
		_tmp11_ = _tmp10_;
		_g_free0 (_tmp9_);
		result = _tmp11_;
		_g_date_time_unref0 (now);
		return result;
	} else {
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
		gboolean _tmp15_;
		_tmp12_ = g_date_time_add_days (date_time, 1);
		_tmp13_ = _tmp12_;
		_tmp14_ = now;
		_tmp15_ = notejot_time_utils_is_same_day (_tmp13_, _tmp14_);
		_g_date_time_unref0 (_tmp13_);
		if (_tmp15_) {
			gchar* _tmp16_;
			_tmp16_ = g_strdup (_ ("Yesterday"));
			result = _tmp16_;
			_g_date_time_unref0 (now);
			return result;
		} else {
			GDateTime* _tmp17_;
			GDateTime* _tmp18_;
			GDateTime* _tmp19_;
			gboolean _tmp20_;
			_tmp17_ = g_date_time_add_days (date_time, -1);
			_tmp18_ = _tmp17_;
			_tmp19_ = now;
			_tmp20_ = notejot_time_utils_is_same_day (_tmp18_, _tmp19_);
			_g_date_time_unref0 (_tmp18_);
			if (_tmp20_) {
				gchar* _tmp21_;
				_tmp21_ = g_strdup (_ ("Tomorrow"));
				result = _tmp21_;
				_g_date_time_unref0 (now);
				return result;
			} else {
				gboolean _tmp22_ = FALSE;
				if (diff < (6 * G_TIME_SPAN_DAY)) {
					_tmp22_ = diff > (-6 * G_TIME_SPAN_DAY);
				} else {
					_tmp22_ = FALSE;
				}
				if (_tmp22_) {
					gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					_tmp23_ = notejot_time_utils_get_default_date_format (TRUE, FALSE, FALSE);
					_tmp24_ = _tmp23_;
					_tmp25_ = g_date_time_format (date_time, _tmp24_);
					_tmp26_ = _tmp25_;
					_g_free0 (_tmp24_);
					result = _tmp26_;
					_g_date_time_unref0 (now);
					return result;
				} else {
					GDateTime* _tmp27_;
					_tmp27_ = now;
					if (g_date_time_get_year (date_time) == g_date_time_get_year (_tmp27_)) {
						gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
						_tmp28_ = notejot_time_utils_get_default_date_format (FALSE, TRUE, FALSE);
						_tmp29_ = _tmp28_;
						_tmp30_ = g_date_time_format (date_time, _tmp29_);
						_tmp31_ = _tmp30_;
						_g_free0 (_tmp29_);
						result = _tmp31_;
						_g_date_time_unref0 (now);
						return result;
					} else {
						gchar* _tmp32_;
						_tmp32_ = g_date_time_format (date_time, "%x");
						result = _tmp32_;
						_g_date_time_unref0 (now);
						return result;
					}
				}
			}
		}
	}
}

gchar*
notejot_time_utils_get_relative_datetime_compact (GDateTime* date_time)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gboolean _tmp8_ = FALSE;
	gchar* result;
	g_return_val_if_fail (date_time != NULL, NULL);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = now;
	diff = g_date_time_difference (_tmp1_, date_time);
	_tmp2_ = now;
	if (notejot_time_utils_is_same_day (date_time, _tmp2_)) {
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		if (diff > ((GTimeSpan) 0)) {
			if (diff < (12 * G_TIME_SPAN_HOUR)) {
				gchar* _tmp3_;
				_tmp3_ = g_date_time_format (date_time, "%H:%M");
				result = _tmp3_;
				_g_date_time_unref0 (now);
				return result;
			}
		}
		_tmp4_ = notejot_time_utils_get_default_time_format (notejot_time_utils_is_clock_format_12h (), FALSE);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_date_time_format (date_time, _tmp5_);
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp5_);
		result = _tmp7_;
		_g_date_time_unref0 (now);
		return result;
	}
	if (diff < (6 * G_TIME_SPAN_DAY)) {
		_tmp8_ = diff > (-6 * G_TIME_SPAN_DAY);
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		gchar* _tmp9_;
		_tmp9_ = g_date_time_format (date_time, "%A");
		result = _tmp9_;
		_g_date_time_unref0 (now);
		return result;
	} else {
		gchar* _tmp10_;
		_tmp10_ = g_date_time_format (date_time, "%d/%m");
		result = _tmp10_;
		_g_date_time_unref0 (now);
		return result;
	}
}

NotejotTimeUtils*
notejot_time_utils_construct (GType object_type)
{
	NotejotTimeUtils* self = NULL;
	self = (NotejotTimeUtils*) g_type_create_instance (object_type);
	return self;
}

NotejotTimeUtils*
notejot_time_utils_new (void)
{
	return notejot_time_utils_construct (NOTEJOT_TYPE_TIME_UTILS);
}

static void
notejot_value_time_utils_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
notejot_value_time_utils_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		notejot_time_utils_unref (value->data[0].v_pointer);
	}
}

static void
notejot_value_time_utils_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = notejot_time_utils_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
notejot_value_time_utils_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
notejot_value_time_utils_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		NotejotTimeUtils * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = notejot_time_utils_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
notejot_value_time_utils_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	NotejotTimeUtils ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = notejot_time_utils_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
notejot_param_spec_time_utils (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	NotejotParamSpecTimeUtils* spec;
	g_return_val_if_fail (g_type_is_a (object_type, NOTEJOT_TYPE_TIME_UTILS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
notejot_value_get_time_utils (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NOTEJOT_TYPE_TIME_UTILS), NULL);
	return value->data[0].v_pointer;
}

void
notejot_value_set_time_utils (GValue* value,
                              gpointer v_object)
{
	NotejotTimeUtils * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NOTEJOT_TYPE_TIME_UTILS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NOTEJOT_TYPE_TIME_UTILS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		notejot_time_utils_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		notejot_time_utils_unref (old);
	}
}

void
notejot_value_take_time_utils (GValue* value,
                               gpointer v_object)
{
	NotejotTimeUtils * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NOTEJOT_TYPE_TIME_UTILS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NOTEJOT_TYPE_TIME_UTILS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		notejot_time_utils_unref (old);
	}
}

static void
notejot_time_utils_class_init (NotejotTimeUtilsClass * klass,
                               gpointer klass_data)
{
	notejot_time_utils_parent_class = g_type_class_peek_parent (klass);
	((NotejotTimeUtilsClass *) klass)->finalize = notejot_time_utils_finalize;
}

static void
notejot_time_utils_instance_init (NotejotTimeUtils * self,
                                  gpointer klass)
{
	self->ref_count = 1;
}

static void
notejot_time_utils_finalize (NotejotTimeUtils * obj)
{
	NotejotTimeUtils * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOTEJOT_TYPE_TIME_UTILS, NotejotTimeUtils);
	g_signal_handlers_destroy (self);
}

static GType
notejot_time_utils_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { notejot_value_time_utils_init, notejot_value_time_utils_free_value, notejot_value_time_utils_copy_value, notejot_value_time_utils_peek_pointer, "p", notejot_value_time_utils_collect_value, "p", notejot_value_time_utils_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (NotejotTimeUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notejot_time_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotejotTimeUtils), 0, (GInstanceInitFunc) notejot_time_utils_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType notejot_time_utils_type_id;
	notejot_time_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NotejotTimeUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return notejot_time_utils_type_id;
}

GType
notejot_time_utils_get_type (void)
{
	static volatile gsize notejot_time_utils_type_id__once = 0;
	if (g_once_init_enter (&notejot_time_utils_type_id__once)) {
		GType notejot_time_utils_type_id;
		notejot_time_utils_type_id = notejot_time_utils_get_type_once ();
		g_once_init_leave (&notejot_time_utils_type_id__once, notejot_time_utils_type_id);
	}
	return notejot_time_utils_type_id__once;
}

gpointer
notejot_time_utils_ref (gpointer instance)
{
	NotejotTimeUtils * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
notejot_time_utils_unref (gpointer instance)
{
	NotejotTimeUtils * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		NOTEJOT_TIME_UTILS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

